/******************************************************************************/
/*                                                                            */
/*                    CAO & VLSI's cad tools chain Alliance                   */
/*                                                                            */
/*     Product  : Testability Design Rule Checker                             */
/*     File     : @(#)                                                        */
/*     Contents :                                                             */
/*                                                                            */
/*     (c) Copyright 1992 Laboratoire MASI equipe CAO & VLSI                  */
/*     All rights reserved                                                    */
/*     Hot line  : cao-vlsi@masi.ibp.fr (e-mail)                              */
/*                                                                            */
/*     Author(s)   :                                    Date : ../../....     */
/*     Modified by :                                    Date : ../../....     */
/*     Modified by :                                    Date : ../../....     */
/*     Modified by :                                    Date : ../../....     */
/*                                                                            */
/******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mbk_inc.h"
#include "scp_fonc.h"
#define NONE -1
#define NBCELLMAX 5000
#define NBNETMAX 5000
#define NBROWMAX 50
#define NBCONMAX 100
#define NBMODIF_MIN 1
#define TEMP_INIT 100 
int PRE_PLACE;
int PRE_PLACE_LENGTH;
int PRE_PLACE_ROW;
int FILL;
int NBCELL;
int NB_FIX_CELL;
int NB_FREE_CELL;
int NB_PREP_CON;
int NB_CON[4];
int NBNET;
int NBROW;
int HEIGHT;
int NBMODIF;
float DELTA_C;
float DELTA_C_1;
float DELTA_C_11;
float DELTA_C_2;
float COUT;
float NORM_NBROW;
float NORM_NBCELL;
float TEMPERATURE;
int IDEAL_ROW_LENGTH;
int TOTAL_LENGTH;
int FREE_CELL_LENGTH;
int IDEAL_NBROW;
long X_WEIGHT;
long Y_WEIGHT;
extern long SCALE_X;
char *figname[30];

/******************* structure de donnees par cellules ************************/

struct cell_struct
{
	int width;
	int pos;
	int row;
	int last;
	int next;
	struct connect_list_struct *first;
};

struct cell_struct CELL[NBCELLMAX];

struct connect_list_struct
{
	int net_number;
	struct connect_list_struct *next;
};

/******************* structure de donnees par nets *** ************************/

struct net_struct 
{
	float weight;
	float coeff;
	int node_number;
	struct cell_list_struct *first;
};

struct net_struct NET[NBNETMAX];

struct cell_list_struct
{
	int cell_number;
	struct cell_list_struct *next;
};

/******************* structure de donnees par colonnes ************************/

struct row_struct
{
	int free;
	int length;
	int first;
	int last;
	int number_cell;
};

struct row_struct ROW[NBROWMAX];

/********* parametres de la modification de la configuration courante *********/

struct modif_struct
{
	int type;
	int cell1;
	int cell2;
	int before;
	int nextpos[NBCELLMAX];
	int deltawidth[NBCELLMAX];
};

struct modif_struct MODIF;

/******** structure de memorisation des references des cellules ***************/

struct cell_ref_struct
{
	char *figname;
	char *insname;
};

struct cell_ref_struct CELL_REF[NBCELLMAX];

